Index: pjproject/trunk/pjsip/src/pjsip/sip_dialog.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_dialog.c	(revision 138)
+++ pjproject/trunk/pjsip/src/pjsip/sip_dialog.c	(revision 139)
@@ -38,4 +38,5 @@
 #define THIS_FILE	"sip_dialog.c"
 
+long pjsip_dlg_lock_tls_id;
 
 PJ_DEF(pj_bool_t) pjsip_method_creates_dialog(const pjsip_method *m)
@@ -73,4 +74,5 @@
     pj_sprintf(dlg->obj_name, "dlg%p", dlg);
     dlg->ua = ua;
+    dlg->endpt = endpt;
 
     status = pj_mutex_create_recursive(pool, "dlg%p", &dlg->mutex);
@@ -93,5 +95,5 @@
     if (dlg->mutex)
 	pj_mutex_destroy(dlg->mutex);
-    pjsip_endpt_release_pool(pjsip_ua_get_endpt(dlg->ua), dlg->pool);
+    pjsip_endpt_release_pool(dlg->endpt, dlg->pool);
 }
 
@@ -145,5 +147,5 @@
     /* Randomize local CSeq. */
     dlg->local.first_cseq = pj_rand() % 0x7FFFFFFFL;
-    dlg->local.cseq = dlg->local.cseq;
+    dlg->local.cseq = dlg->local.first_cseq;
 
     /* Init local contact. */
@@ -184,5 +186,5 @@
 
     /* Init client authentication session. */
-    status = pjsip_auth_clt_init(&dlg->auth_sess, pjsip_ua_get_endpt(ua), 
+    status = pjsip_auth_clt_init(&dlg->auth_sess, dlg->endpt, 
 				 dlg->pool, 0);
     if (status != PJ_SUCCESS)
@@ -343,5 +345,5 @@
 
     /* Init client authentication session. */
-    status = pjsip_auth_clt_init(&dlg->auth_sess, pjsip_ua_get_endpt(ua),
+    status = pjsip_auth_clt_init(&dlg->auth_sess, dlg->endpt,
 				 dlg->pool, 0);
     if (status != PJ_SUCCESS)
@@ -507,7 +509,10 @@
     }
 
+    /* Log */
+    PJ_LOG(5,(dlg->obj_name, "Dialog destroyed"));
+
     /* Destroy this dialog. */
     pj_mutex_destroy(dlg->mutex);
-    pjsip_endpt_release_pool(pjsip_ua_get_endpt(dlg->ua), dlg->pool);
+    pjsip_endpt_release_pool(dlg->endpt, dlg->pool);
 
     return PJ_SUCCESS;
@@ -630,4 +635,7 @@
     dlg->mod_data[mod->id] = mod_data;
 
+    /* Increment count. */
+    ++dlg->usage_cnt;
+
     pj_mutex_unlock(dlg->mutex);
 
@@ -664,5 +672,5 @@
      * dialog.
      */
-    status = pjsip_endpt_create_request_from_hdr(pjsip_ua_get_endpt(dlg->ua),
+    status = pjsip_endpt_create_request_from_hdr(dlg->endpt,
 						 method,
 						 dlg->target,
@@ -810,13 +818,15 @@
 	}
 
-	*p_tsx = tsx;
+	if (p_tsx)
+	    *p_tsx = tsx;
 
     } else {
-	status = pjsip_endpt_send_request_stateless(
-		    pjsip_ua_get_endpt(dlg->ua), tdata, NULL, NULL);
+	status = pjsip_endpt_send_request_stateless(dlg->endpt, tdata, 
+						    NULL, NULL);
 	if (status != PJ_SUCCESS)
 	    goto on_error;
 
-	*p_tsx = NULL;
+	if (p_tsx)
+	    *p_tsx = NULL;
     }
 
@@ -833,5 +843,6 @@
     pjsip_tx_data_dec_ref( tdata );
 
-    *p_tsx = NULL;
+    if (p_tsx)
+	*p_tsx = NULL;
     return status;
 }
@@ -853,5 +864,5 @@
 
     /* Create generic response. */
-    status = pjsip_endpt_create_response(pjsip_ua_get_endpt(dlg->ua),
+    status = pjsip_endpt_create_response(dlg->endpt,
 					 rdata, st_code, st_text, &tdata);
     if (status != PJ_SUCCESS)
@@ -915,5 +926,5 @@
 	if (st_class==2 || st_code==405) {
 	    const pjsip_hdr *c_hdr;
-	    c_hdr = pjsip_endpt_get_capability(pjsip_ua_get_endpt(dlg->ua),
+	    c_hdr = pjsip_endpt_get_capability(dlg->endpt,
 					       PJSIP_H_ALLOW, NULL);
 	    if (c_hdr) {
@@ -926,5 +937,5 @@
 	if (st_class==2) {
 	    const pjsip_hdr *c_hdr;
-	    c_hdr = pjsip_endpt_get_capability(pjsip_ua_get_endpt(dlg->ua),
+	    c_hdr = pjsip_endpt_get_capability(dlg->endpt,
 					       PJSIP_H_SUPPORTED, NULL);
 	    if (c_hdr) {
@@ -1057,5 +1068,5 @@
 	 */
 	pj_mutex_unlock(dlg->mutex);
-	pjsip_endpt_respond_stateless(pjsip_ua_get_endpt(dlg->ua),
+	pjsip_endpt_respond_stateless(dlg->endpt,
 				      rdata, 500, NULL, NULL, NULL);
 	return;
@@ -1095,5 +1106,5 @@
 		  "Dialog will response with 500 (Internal Server Error)",
 		  pjsip_rx_data_get_info(rdata)));
-	status = pjsip_endpt_create_response(pjsip_ua_get_endpt(dlg->ua), 
+	status = pjsip_endpt_create_response(dlg->endpt, 
 					     rdata, 
 					     PJSIP_SC_INTERNAL_SERVER_ERROR, 
@@ -1126,4 +1137,7 @@
     pj_mutex_lock(dlg->mutex);
 
+    /* Check that rdata already has dialog in mod_data. */
+    pj_assert(pjsip_rdata_get_dlg(rdata) == dlg);
+
     /* Update the remote tag, if none is specified yet. */
     if (dlg->remote.info->tag.slen == 0 && rdata->msg_info.to->tag.slen != 0) {
@@ -1134,6 +1148,17 @@
     }
 
-    /* Check that rdata already has dialog in mod_data. */
-    pj_assert(pjsip_rdata_get_dlg(rdata) == dlg);
+    /* Update remote target when receiving certain response messages. */
+    if (pjsip_method_creates_dialog(&rdata->msg_info.cseq->method) &&
+	rdata->msg_info.msg->line.status.code/100 == 2)
+    {
+	pjsip_contact_hdr *contact;
+
+	contact = pjsip_msg_find_hdr(rdata->msg_info.msg, PJSIP_H_CONTACT, 
+				     NULL);
+	if (contact) {
+	    dlg->remote.contact = pjsip_hdr_clone(dlg->pool, contact);
+	    dlg->target = dlg->remote.contact->uri;
+	}
+    }
 
     /* Pass to dialog usages. */
@@ -1186,4 +1211,7 @@
 	dlg->sess_count == 0) 
     {
+	/* Unregister this dialog from the transaction. */
+	tsx->mod_data[dlg->ua->id] = NULL;
+
 	/* Time to destroy dialog. */
 	unregister_and_destroy_dialog(dlg);
Index: pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 138)
+++ pjproject/trunk/pjsip/src/pjsip/sip_endpoint.c	(revision 139)
@@ -311,4 +311,8 @@
 	default:
 	    return PJ_EINVAL;
+	}
+
+	if (hdr) {
+	    pj_list_push_back(&endpt->cap_hdr, hdr);
 	}
     }
@@ -756,4 +760,9 @@
 
     pj_rwmutex_unlock_read(endpt->mod_mutex);
+
+    /* Must clear mod_data before returning rdata to transport, since
+     * rdata may be reused.
+     */
+    pj_memset(&rdata->endpt_info, 0, sizeof(rdata->endpt_info));
 }
 
Index: pjproject/trunk/pjsip/src/pjsip/sip_msg.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 138)
+++ pjproject/trunk/pjsip/src/pjsip/sip_msg.c	(revision 139)
@@ -1703,4 +1703,38 @@
 ///////////////////////////////////////////////////////////////////////////////
 /*
+ * Warning header.
+ */
+PJ_DEF(pjsip_warning_hdr*) pjsip_warning_hdr_create(  pj_pool_t *pool,
+						      int code,
+						      const pj_str_t *host,
+						      const pj_str_t *text)
+{
+    const pj_str_t str_warning = { "Warning", 7 };
+    pj_str_t hvalue;
+
+    hvalue.ptr = pj_pool_alloc(pool, 10 +		/* code */
+				     host->slen + 2 +	/* host */
+				     text->slen + 2);	/* text */
+    hvalue.slen = pj_sprintf(hvalue.ptr, "%u %.*s \"%.*s\"",
+			     code, host->slen, host->ptr,
+			     text->slen, text->ptr);
+
+    return pjsip_generic_string_hdr_create(pool, &str_warning, &hvalue);
+}
+
+PJ_DEF(pjsip_warning_hdr*) 
+pjsip_warning_hdr_create_from_status( pj_pool_t *pool,
+				      const pj_str_t *host,
+				      pj_status_t status)
+{
+    char errbuf[PJ_ERR_MSG_SIZE];
+    pj_str_t text;
+    
+    text = pj_strerror(status, errbuf, sizeof(errbuf));
+    return pjsip_warning_hdr_create(pool, 399, host, &text);
+}
+
+///////////////////////////////////////////////////////////////////////////////
+/*
  * Message body manipulations.
  */
Index: pjproject/trunk/pjsip/src/pjsip/sip_transaction.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 138)
+++ pjproject/trunk/pjsip/src/pjsip/sip_transaction.c	(revision 139)
@@ -32,4 +32,11 @@
 
 #define THIS_FILE   "sip_transaction.c"
+
+#if 0
+#define TSX_TRACE_(expr)    PJ_LOG(3,expr)
+#else
+#define TSX_TRACE_(expr)
+#endif
+
 
 /*****************************************************************************
@@ -505,18 +512,24 @@
     pj_mutex_lock(mod_tsx_layer.mutex);
 
-    /* Check if no transaction with the same key exists. */
-    PJ_ASSERT_ON_FAIL(pj_hash_get( mod_tsx_layer.htable, 
-				   &tsx->transaction_key.ptr,
-				   tsx->transaction_key.slen, 
-				   &tsx->hashed_key) == NULL,
-			{
-			    pj_mutex_unlock(mod_tsx_layer.mutex);
-			    return PJ_EEXISTS;
-			}
-		      );
+    /* Check if no transaction with the same key exists. 
+     * Do not use PJ_ASSERT_RETURN since it evaluates the expression
+     * twice!
+     */
+    pj_assert(pj_hash_get( mod_tsx_layer.htable, 
+			   &tsx->transaction_key.ptr,
+			   tsx->transaction_key.slen, 
+			   NULL) == NULL);
+
+    TSX_TRACE_((THIS_FILE, 
+		"Transaction %p registered with hkey=0x%p and key=%.*s",
+		tsx, tsx->hashed_key, tsx->transaction_key.slen,
+		tsx->transaction_key.ptr));
 
     /* Register the transaction to the hash table. */
+    //pj_hash_set( tsx->pool, mod_tsx_layer.htable, tsx->transaction_key.ptr,
+    //		 tsx->transaction_key.slen, tsx->hashed_key, tsx);
+    PJ_TODO(USE_PRECALCULATED_HASHED_VALUE);
     pj_hash_set( tsx->pool, mod_tsx_layer.htable, tsx->transaction_key.ptr,
-		 tsx->transaction_key.slen, tsx->hashed_key, tsx);
+    		 tsx->transaction_key.slen, 0, tsx);
 
     /* Unlock mutex. */
@@ -539,6 +552,14 @@
 
     /* Register the transaction to the hash table. */
+    //pj_hash_set( NULL, mod_tsx_layer.htable, tsx->transaction_key.ptr,
+    //		 tsx->transaction_key.slen, tsx->hashed_key, NULL);
+    PJ_TODO(USE_PRECALCULATED_HASHED_VALUE);
     pj_hash_set( NULL, mod_tsx_layer.htable, tsx->transaction_key.ptr,
-		 tsx->transaction_key.slen, tsx->hashed_key, NULL);
+		 tsx->transaction_key.slen, 0, NULL);
+
+    TSX_TRACE_((THIS_FILE, 
+		"Transaction %p unregistered, hkey=0x%p and key=%.*s",
+		tsx, tsx->hashed_key, tsx->transaction_key.slen,
+		tsx->transaction_key.ptr));
 
     /* Unlock mutex. */
@@ -554,9 +575,13 @@
 {
     pjsip_transaction *tsx;
+    pj_uint32_t hval = 0;
 
     pj_mutex_lock(mod_tsx_layer.mutex);
-    tsx = pj_hash_get( mod_tsx_layer.htable, key->ptr, key->slen, NULL );
+    tsx = pj_hash_get( mod_tsx_layer.htable, key->ptr, key->slen, &hval );
     pj_mutex_unlock(mod_tsx_layer.mutex);
 
+    TSX_TRACE_((THIS_FILE, 
+		"Finding tsx with hkey=0x%p and key=%.*s: found %p",
+		hval, key->slen, key->ptr, tsx));
 
     /* Race condition!
@@ -642,4 +667,5 @@
 {
     pj_str_t key;
+    pj_uint32_t hval = 0;
     pjsip_transaction *tsx;
 
@@ -650,5 +676,11 @@
     pj_mutex_lock( mod_tsx_layer.mutex );
 
-    tsx = pj_hash_get( mod_tsx_layer.htable, key.ptr, key.slen, NULL );
+    tsx = pj_hash_get( mod_tsx_layer.htable, key.ptr, key.slen, &hval );
+
+
+    TSX_TRACE_((THIS_FILE, 
+		"Finding tsx for request, hkey=0x%p and key=%.*s, found %p",
+		hval, key.slen, key.ptr, tsx));
+
 
     if (tsx == NULL || tsx->state == PJSIP_TSX_STATE_TERMINATED) {
@@ -683,4 +715,5 @@
 {
     pj_str_t key;
+    pj_uint32_t hval = 0;
     pjsip_transaction *tsx;
 
@@ -691,5 +724,11 @@
     pj_mutex_lock( mod_tsx_layer.mutex );
 
-    tsx = pj_hash_get( mod_tsx_layer.htable, key.ptr, key.slen, NULL );
+    tsx = pj_hash_get( mod_tsx_layer.htable, key.ptr, key.slen, &hval );
+
+
+    TSX_TRACE_((THIS_FILE, 
+		"Finding tsx for response, hkey=0x%p and key=%.*s, found %p",
+		hval, key.slen, key.ptr, tsx));
+
 
     if (tsx == NULL || tsx->state == PJSIP_TSX_STATE_TERMINATED) {
@@ -919,5 +958,26 @@
     }
 
-    /* Inform TU */
+    /* Before informing TU about state changed, inform TU about
+     * rx event.
+     */
+    if (event_src_type==PJSIP_EVENT_RX_MSG && tsx->tsx_user) {
+	pjsip_rx_data *rdata = event_src;
+
+	pj_assert(rdata != NULL);
+
+	if (rdata->msg_info.msg->type == PJSIP_REQUEST_MSG &&
+	    tsx->tsx_user->on_rx_request)
+	{
+	    (*tsx->tsx_user->on_rx_request)(rdata);
+
+	} else if (rdata->msg_info.msg->type == PJSIP_RESPONSE_MSG &&
+		   tsx->tsx_user->on_rx_response)
+	{
+	    (*tsx->tsx_user->on_rx_response)(rdata);
+	}
+
+    }
+
+    /* Inform TU about state changed. */
     if (tsx->tsx_user && tsx->tsx_user->on_tsx_state) {
 	pjsip_event e;
@@ -1045,6 +1105,11 @@
 
     /* Calculate hashed key value. */
+    PJ_TODO(OPTIMIZE_TSX_BY_PRECALCULATING_HASHED_KEY_VALUE);
+    /*
+     blp: somehow this yields different hashed value!!
+
     tsx->hashed_key = pj_hash_calc(0, tsx->transaction_key.ptr,
 				   tsx->transaction_key.slen);
+     */
 
     PJ_LOG(6, (tsx->obj_name, "tsx_key=%.*s", tsx->transaction_key.slen,
@@ -1159,6 +1224,11 @@
 
     /* Calculate hashed key value. */
+    PJ_TODO(OPTIMIZE_TSX_BY_PRECALCULATING_HASHED_KEY_VALUE);
+    /*
+     blp: somehow this yields different hashed value!!
+
     tsx->hashed_key = pj_hash_calc(0, tsx->transaction_key.ptr,
 				   tsx->transaction_key.slen);
+     */
 
     /* Duplicate branch parameter for transaction. */
Index: pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c	(revision 138)
+++ pjproject/trunk/pjsip/src/pjsip/sip_ua_layer.c	(revision 139)
@@ -169,6 +169,9 @@
     dlg = tsx->mod_data[mod_ua.mod.id];
     
-    /* Must have the dialog instance! */
-    PJ_ASSERT_ON_FAIL(dlg != NULL, return);
+    /* If dialog instance has gone, it could mean that the dialog
+     * may has been destroyed.
+     */
+    if (dlg == NULL)
+	return;
 
     /* Hand over the event to the dialog. */
@@ -205,4 +208,15 @@
 {
     return &mod_ua.mod;
+}
+
+
+/*
+ * Get the endpoint where this UA is currently registered.
+ */
+PJ_DEF(pjsip_endpoint*) pjsip_ua_get_endpt(pjsip_user_agent *ua)
+{
+    PJ_UNUSED_ARG(ua);
+    pj_assert(ua == &mod_ua.mod);
+    return mod_ua.endpt;
 }
 
@@ -461,4 +475,8 @@
     pjsip_dialog *dlg;
 
+    /* Optimized path: bail out early if request doesn't have To tag */
+    if (rdata->msg_info.to->tag.slen == 0)
+	return PJ_FALSE;
+
     /* Lock user agent before looking up the dialog hash table. */
     pj_mutex_lock(mod_ua.mutex);
@@ -467,9 +485,15 @@
     dlg_set = find_dlg_set_for_msg(rdata);
 
-    /* Bail out if dialog is not found. */
+    /* If dialog is not found, respond with 481 (Call/Transaction
+     * Does Not Exist).
+     */
     if (dlg_set == NULL) {
-	/* Not ours. */
+	/* Unable to find dialog. */
 	pj_mutex_unlock(mod_ua.mutex);
-	return PJ_FALSE;
+
+	/* Respond with 481 . */
+	pjsip_endpt_respond_stateless( mod_ua.endpt, rdata, 481, NULL, NULL,
+				       NULL );
+	return PJ_TRUE;
     }
 
@@ -531,5 +555,5 @@
     /* Check if transaction is present. */
     tsx = pjsip_rdata_get_tsx(rdata);
-    if (!tsx) {
+    if (tsx) {
 	/* Check if dialog is present in the transaction. */
 	dlg = pjsip_tsx_get_dlg(tsx);
Index: pjproject/trunk/pjsip/src/pjsip/sip_util.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsip/sip_util.c	(revision 138)
+++ pjproject/trunk/pjsip/src/pjsip/sip_util.c	(revision 139)
@@ -44,9 +44,5 @@
     "TRANSPORT_ERROR",
     "TSX_STATE",
-    "RX_2XX_RESPONSE",
-    "RX_ACK",
-    "DISCARD_MSG",
     "USER",
-    "BEFORE_TX",
 };
 
Index: pjproject/trunk/pjsip/src/pjsua/getopt.c
===================================================================
--- pjproject/trunk/pjsip/src/pjsua/getopt.c	(revision 138)
+++ pjproject/trunk/pjsip/src/pjsua/getopt.c	(revision 139)
@@ -36,4 +36,6 @@
 #include "config.h"
 #endif
+
+#include <pj/string.h>
 
 #ifndef HAVE_GETOPT_LONG
